# Graph Test Cases

There are test cases for the merge-riser coalescing logic that
was added on 2020-06-08.

  *  [e19cfba5373369b](/info/e19cfba5373369b?diff=0)
  *  [c779b6890464cae](/info/c779b6890464cae?diff=0)
  *  [eed3946bd92a499](/info/eed3946bd92a499?diff=0)
  *  [9e1fa626e47f147](/info/9e1fa626e47f147?diff=0)
  *  [68bd2e7bedb8d05](/info/68bd2e7bedb8d05?diff=0)
  *  [8ac66ef33b464d2](/info/8ac66ef33b464d2?diff=0)
  *  [ef6979eac9abded](/info/ef6979eac9abded?diff=0)
  *  [7766e689926c703](/info/7766e689926c703?diff=0)
  *  [642f4dcfa24f1f9](/info/642f4dcfa24f1f9?diff=0)
  *  [3ea66260b5555d2](/info/3ea66260b5555d2?diff=0)
  *  [66ae70a54b20656](/info/66ae70a54b20656?diff=0)
  *  [b0f2a0ac53926c9](/info/b0f2a0ac53926c9?diff=0)
  *  [303e7af7c31866c](/info/303e7af7c31866c?diff=0)
  *  [b31afcc2cab1dc4](/info/b31afcc2cab1dc4?diff=0)
  *  [1a164e5fb76a46b](/info/1a164e5fb76a46b?diff=0)
  *  [f325b2343e6a18f](/info/f325b2343e6a18f?diff=0)
  *  [2d75e87b760c0a9](/info/2d75e87b760c0a9?diff=0)
  *  [76442af7e13267b](/info/76442af7e13267b?diff=0)


The list above was generated by the following script:

~~~~~
.mode list
SELECT printf('  *  [%s](/info/%s?diff=0)', hash, hash) FROM (
  SELECT count(*) AS cnt, sum(cherrypick=1) AS cp, sum(cherrypick=0) AS n, 
      (SELECT substr(uuid,1,15) FROM blob WHERE rid=cid) AS hash
    FROM (
      SELECT cid, 0 AS cherrypick FROM plink WHERE NOT isprim
      UNION ALL
      SELECT childid, 1 FROM cherrypick
    )
   GROUP BY cid
   HAVING (cp>0 AND n>0) OR cp>3 OR n>2
   ORDER BY cnt
);
~~~~~

Similar links to the SQLite repository:

  *  [7f72fc4f47445a2](https://sqlite.org/src/info/7f72fc4f47445a2?diff=0)
  *  [db2935473eab91c](https://sqlite.org/src/info/db2935473eab91c?diff=0)
  *  [a56506b9387a067](https://sqlite.org/src/info/a56506b9387a067?diff=0)
  *  [d59567dda231e7f](https://sqlite.org/src/info/d59567dda231e7f?diff=0)
  *  [2b750b0f74e5a11](https://sqlite.org/src/info/2b750b0f74e5a11?diff=0)
  *  [c697d2f83c2d8ea](https://sqlite.org/src/info/c697d2f83c2d8ea?diff=0)
  *  [b330c7ff6fd1230](https://sqlite.org/src/info/b330c7ff6fd1230?diff=0)
  *  [746fcd2fd412ddc](https://sqlite.org/src/info/746fcd2fd412ddc?diff=0)
  *  [71866b367f32b5a](https://sqlite.org/src/info/71866b367f32b5a?diff=0)
  *  [05418b2a4a6e6a9](https://sqlite.org/src/info/05418b2a4a6e6a9?diff=0)

Generated by a very similar script:

~~~~~
SELECT printf('  *  [%s](https://sqlite.org/src/info/%s?diff=0)', hash, hash) FROM (
  SELECT count(*) AS cnt, sum(cherrypick=1) AS cp, sum(cherrypick=0) AS n, 
      (SELECT substr(uuid,1,15) FROM blob WHERE rid=cid) AS hash
    FROM (
      SELECT cid, 0 AS cherrypick FROM plink WHERE NOT isprim
      UNION ALL
      SELECT childid, 1 FROM cherrypick
    )
   GROUP BY cid
   HAVING (cp>0 AND n>0) OR cp>2 OR n>2
   ORDER BY cnt
);
~~~~~
